(function (Drupal, $) {

  const waitShort = 1000;
  const waitLong = 30000;

  let init = false;
  let timeout = false;

  Drupal.behaviors.interactiveQueueProcessing = {
    attach: function (context, settings) {
      if (init) {
        return;
      }
      init = true;
      setNextAjax(settings, settings.interactive_queue_processing.counts > 0 ? waitShort : waitLong);
    }
  };

  function doAjax(settings) {
    let url = settings.path.baseUrl + 'interactive-queue-processing/ajax';
    $.ajax(url).done(function (data) {
      setNextAjax(settings, data.remaining > 0 ? waitShort : waitLong);
    });
  }

  function setNextAjax(settings, pause) {
    // Don't adjust timeout if there is currently a pending timeout.
    if (timeout) {
      return;
    }

    timeout = setTimeout(function () {
      // When the timeout is executed, unset the timeout and do the AJAX.
      timeout = false;
      doAjax(settings);
    }, pause);
  }

})(Drupal, jQuery)
